#include <locale.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

typedef unsigned char uint8_t;

ssize_t _hs_text_measure_off(const uint8_t *src, size_t off, size_t len, size_t cnt);

int
main(void)
{
	char buf[BUFSIZ];

	setlocale(LC_ALL, "");
	while (fgets(buf, sizeof buf, stdin) != NULL) {
		size_t len = strlen(buf);

		/*
		 * In the C/POSIX locale, glibc returns -1 when fed UTF-8
		 * strings; *BSDs treat them as simple bytes--ie. cnt == len
		 */
		size_t cnt = mbstowcs(NULL, buf, 0);
		if (cnt == (size_t)-1)
			continue;
		ssize_t n = _hs_text_measure_off(buf, 0, len, cnt);
		printf("len=%zu, cnt=%zu, hs=%zd\n", len, cnt, n);
	}
	return 0;
}
